mod commands;
mod structs;
mod utils;
use clap::{App, AppSettings, Arg, SubCommand};
extern crate tokio;

fn main() {
    let matches = App::new("hentaihavenrs")
        .about("hentaihaven.tv downloader in rust")
        .version(env!("CARGO_PKG_VERSION"))
        .setting(AppSettings::SubcommandRequiredElseHelp)
        .subcommand(
            SubCommand::with_name("search")
            .arg(
                Arg::with_name("query")
                    .takes_value(true)
                    .multiple(true)
                    .help("Search query")
            )
        )
        .subcommand(
            SubCommand::with_name("view")
            .aliases(&["info", "show"])
            .arg(
                Arg::with_name("id")
                    .takes_value(true)
                    .multiple(true)
                    .required(true)
            )
        )
        .subcommand(
            SubCommand::with_name("download")
            .alias("dl")
            .arg(
                Arg::with_name("print")
                    .long("print")
                    .short("p")
                    .help("Print the URL to download only")
            ).arg(
                Arg::with_name("id")
                    .takes_value(true)
                    .required(true)
            )
        )
        .get_matches();

    let runtime = tokio::runtime::Builder::new_current_thread()
        .enable_all()
        .build()
        .unwrap();
    match matches.subcommand() {
        ("search", Some(sub_m)) => runtime.block_on(commands::search(sub_m)),
        ("view", Some(sub_m)) => runtime.block_on(commands::view(sub_m)),
        ("download", Some(sub_m)) => runtime.block_on(commands::download(sub_m)),
        _ => panic!("AppSettings::SubcommandRequiredElseHelp do your job please")
    };
}
